/*
TreeSplicer, a framework to enhance temporal locality in repeated tree traversals.
Youngjoon Jo (yjo@purdue.edu)
https://sites.google.com/site/treesplicer/

Copyright 2012, School of Electrical and Computer Engineering, Purdue University.

These benchmarks are adapted from the Lonestar benchmark suite:
http://iss.ices.utexas.edu/?p=projects/galois/lonestar
 */

package barneshut;

public class Node {
	OctTreeNodeData data;
	public Node child0;
	public Node child1;
	public Node child2;
	public Node child3;
	public Node child4;
	public Node child5;
	public Node child6;
	public Node child7;
	
	public Node(OctTreeNodeData data) {
		this.data = data;
	}
	
	public OctTreeNodeData getData() {
		return data;
	}
	
	public Node getChild(int i) {
		switch (i) {
		case 0: return child0;
		case 1: return child1;
		case 2: return child2;
		case 3: return child3;
		case 4: return child4;
		case 5: return child5;
		case 6: return child6;
		case 7: return child7;
		}
		return null;
	}
	
	public void setChild(int i, Node n) {
		switch (i) {
		case 0: child0 = n; break;
		case 1: child1 = n; break;
		case 2: child2 = n; break;
		case 3: child3 = n; break;
		case 4: child4 = n; break;
		case 5: child5 = n; break;
		case 6: child6 = n; break;
		case 7: child7 = n; break;
		}
	}
}
