# TreeSplicer, a framework to enhance temporal locality in repeated tree traversals.
# Youngjoon Jo (yjo@purdue.edu)
# https://sites.google.com/site/treesplicer/
#
# Copyright 2012, School of Electrical and Computer Engineering, Purdue University.

use strict;
use warnings;
require "scripts/common.pl";

my @apps = qw/barneshut pointcorrelation nearestneighbor 
	knearestneighborsplitplane knearestneighborballtreeopt/;
#my @apps = qw/nearestneighbor/;

my @confs = qw/small medium large/;
#my @confs = qw/medium large medium-real large-real/;
#my @confs = qw/small-real medium-real large-real/;

my @sorts = qw/false/;
my $mem = "12G";

print "TreeSplicer batch test all script\n";
print "This script runs the following apps: @apps\n";
print "for each config: @confs\n";
print "with sorting: @sorts\n";
print "and outputs runtime stats to stats.csv\n";

exec_cmd("rm -f stats.csv");

foreach my $app (@apps) {
	foreach my $conf (@confs) {
	foreach my $sort (@sorts) {
		exec_cmd("ant run-app -Dapp=$app -Dconf=$conf -Dmem=$mem -Dsort=$sort  " .
			"-Dkeepstats=true");
	}
	}
}

die "finished\n";
