# TreeSplicer, a framework to enhance temporal locality in repeated tree traversals.
# Youngjoon Jo (yjo@purdue.edu)
# https://sites.google.com/site/treesplicer/
#
# Copyright 2012, School of Electrical and Computer Engineering, Purdue University.

use strict;
use warnings;
require "scripts/common.pl";

my $app = qw/nearestneighbor/;
my $mem = "12G";
my @args = (
	"7 1000000 1000000 random",
	"7 200000 200000 input/nearestneighbor/mnist.7d.gz",
	"7 200000 200000 input/nearestneighbor/covtype.7d.gz",
	);

exec_cmd("rm -f stats.csv");
exec_cmd("rm -f nncorrect.csv");
exec_cmd("ant clean-app -Dapp=$app");

foreach my $arg (@args) {
		exec_cmd("ant run-app -Dapp=$app -Dmem=$mem " .
			"-Dkeepstats=true ".
			"-Dargs=' $arg'");
}

die "finished\n";
