# TreeSplicer, a framework to enhance temporal locality in repeated tree traversals.
# Youngjoon Jo (yjo@purdue.edu)
# https://sites.google.com/site/treesplicer/
#
# Copyright 2012, School of Electrical and Computer Engineering, Purdue University.

use strict;
use warnings;
require "scripts/common.pl";

print "TreeSplicer correct test all script\n";
print "This script checks that the number of nodes traversed in all transformed\n";
print "versions are equal to expected values (of the baseline)\n";

my @apps = qw/barneshut pointcorrelation nearestneighbor 
	knearestneighborsplitplane knearestneighborballtreeopt/;
#my @apps = qw/knearestneighborballtreeopt/;

my @bases = qw/base block splice blocksplice/;

my $mem = "1G";


foreach my $app (@apps) {
	exec_cmd("ant compile-app -Dapp=$app");
	foreach my $base (@bases) {
		exec_cmd("ant run-launcher-conf -Dapp=$app -Dbase=$base -Dconf=correct -Dmem=$mem");
	}
}
exec_cmd("rm -f stats.csv");

die "finished\n";
