# TreeSplicer, a framework to enhance temporal locality in repeated tree traversals.
# Youngjoon Jo (yjo@purdue.edu)
# https://sites.google.com/site/treesplicer/
#
# Copyright 2012, School of Electrical and Computer Engineering, Purdue University.

use strict;
use warnings;
require "scripts/common.pl";

print "Profile JVM heap usage\n";

my $app = "pointcorrelation";

my @args = (
	"3 0.1 1000000 random",
	"7 0.4 200000 input/nearestneighbor/covtype.7d.gz",
	"7 0.4 200000 input/nearestneighbor/mnist.7d.gz",
	);
my $base = "spliceheap";
my @opts = (0, 1, 2);
my @sorts = qw/false/;
my $launcherarg = "--runs 1 --dropruns 0 $app.Main";

my $init_mem = 770;
#my $init_mem = 223;
my $mem = $init_mem;
my $init_dec = 100;
#my $init_dec = 1;
my $dec = $init_dec;

exec_cmd("rm -f heapuse.csv");
foreach my $arg (@args) {
foreach my $sort (@sorts) {
foreach my $opt (@opts) {
	exec_cmd("ant clean-app-custom -Dapp=$app -Dbase=$base ");
	exec_cmd("ant transform-app-custom -Dapp=$app -Dbase=$base ".
	"-Dargs='--outdir $base --noblock --utilstats --spliceopt $opt --noelision $app util'");
	exec_cmd("ant compile-app-custom -Dapp=$app -Dbase=$base");
	while (1) {
		my $memm = $mem . "M";
		my $cmd = "java -cp apps/$base/classes ".
		"-ea -d64 -Xms${memm} -Xmx${memm} " .
		"util.Launcher $launcherarg $sort $arg";
		print "$cmd";
		my $ret = system($cmd);
				if ($ret != 0) {
				  if ($dec == 1) {
				    open (MYFILE, '>>heapuse.csv');
                    print MYFILE "$app, $arg, $sort, $opt, $mem\n";
                    close (MYFILE);
                    $mem = $init_mem;
                    $dec = $init_dec;
				  	last;
				  } else {
				    $mem = $mem + $dec;
				    $dec = $dec / 10;
				  }
				}
                if ($mem == $dec) {
                  $dec = $dec / 10;
				}
				$mem = $mem - $dec;
			}
			}
		}
}

die "finished\n";
