# TreeSplicer, a framework to enhance temporal locality in repeated tree traversals.
# Youngjoon Jo (yjo@purdue.edu)
# https://sites.google.com/site/treesplicer/
#
# Copyright 2012, School of Electrical and Computer Engineering, Purdue University.

use strict;
use warnings;
require "scripts/common.pl";

print "Run Splice with varying opt levels\n";

my $app = "barneshut";

my @args = (
	"false input/barneshut/BarnesHutC.in.gz",
	"true 1000000"
);
#my @args = ("false input/barneshut/BarnesHutC.in.gz");
my $base = "spliceheap";
my @opts = (0, 1, 2);
my @sorts = qw/false/;
my $mem = "12G";

exec_cmd("rm -f stats.csv");
foreach my $arg (@args) {
foreach my $sort (@sorts) {
foreach my $opt (@opts) {
	exec_cmd("ant clean-app-custom -Dapp=$app -Dbase=$base ");
	exec_cmd("ant transform-app-custom -Dapp=$app -Dbase=$base ".
	"-Dargs='--outdir $base --noblock --utilstats --spliceopt $opt $app util'");
	exec_cmd("ant compile-app-custom -Dapp=$app -Dbase=$base");
	exec_cmd("ant run-launcher -Dmem=$mem -Dbase=$base " .
			"-Dargs='--runs 6 --dropruns 1  --desc $opt ".
			"$app.Main $sort $arg'");
			}
			}
}

die "finished\n";
