# TreeSplicer, a framework to enhance temporal locality in repeated tree traversals.
# Youngjoon Jo (yjo@purdue.edu)
# https://sites.google.com/site/treesplicer/
#
# Copyright 2012, School of Electrical and Computer Engineering, Purdue University.

use strict;
use warnings;
require "scripts/common.pl";

print "TreeSplicer single test nearestneighbor\n";

my $app = "barneshut";

my $mem = "12G";
my @papis = (1, 2);
#my @appargs = ("true 1000000");
my @appargs = ("false input/barneshut/BarnesHutC.in.gz");
my @bases = qw/base block splice/;
my @sorts = qw/false true/;

exec_cmd("rm -f papi.csv");
exec_cmd("rm -f stats.csv");
exec_cmd("ant transform-app -Dapp=$app");
exec_cmd("ant compile-app -Dapp=$app");

foreach my $apparg (@appargs) {
foreach my $sort (@sorts) {
foreach my $base (@bases) {
	foreach my $papi (@papis) {
		exec_cmd("ant run-launcher -Dapp=$app -Dbase=$base -Dmem=$mem " .
			"-Dargs='--desc $base --papi $papi ".
			"${app}.Main $sort $apparg'");
	}
	}
	}
}

die "finished\n";
