# TreeSplicer, a framework to enhance temporal locality in repeated tree traversals.
# Youngjoon Jo (yjo@purdue.edu)
# https://sites.google.com/site/treesplicer/
#
# Copyright 2012, School of Electrical and Computer Engineering, Purdue University.

use strict;
use warnings;
require "scripts/common.pl";

my $app = "nearestneighbor";

my $profilerlevel = 1;
my $mem = "12G";
my $base = "blockprofile";

#my @blocks = (1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024);
my @blocks = (512);
my @sorts = qw/true false/;
my $custom3 = 7;
my @args = (
#"3 0.10 10000 random",
#"3 0.10 100000 random",
	"7 1000000 1000000 random",
#	"7 0.4 200000 input/nearestneighbor/covtype.7d.gz",
#	"7 0.4 200000 input/nearestneighbor/mnist.7d.gz"
	);

exec_cmd("rm -f stats.csv");
exec_cmd("rm -f fullstats.csv");
exec_cmd("rm -f profile.csv");

exec_cmd("ant clean-app-custom -Dapp=$app -Dbase=$base");
exec_cmd("ant transform-app-custom -Dapp=$app -Dbase=$base " .
			"-Dargs='--outdir $base --nosplice --noauto ".
			"--utilprofiler ${app} util'");
exec_cmd("ant compile-app-custom -Dapp=$app -Dbase=$base ");
foreach my $arg (@args) {
foreach my $sort (@sorts) {
	foreach my $block (@blocks) {
		exec_cmd("ant run-launcher -Dapp=$app -Dbase=$base -Dmem=$mem " .
			"-Dargs='--runs 1 --dropruns 0 --desc $base --blocksize $block ".
			"--profiler $profilerlevel --custom3 $custom3 ".
			"${app}.Main $sort $arg'");
	}
}
}

die "finished\n";
