# TreeSplicer, a framework to enhance temporal locality in repeated tree traversals.
# Youngjoon Jo (yjo@purdue.edu)
#
# Copyright 2011, School of Electrical and Computer Engineering, Purdue University.

use strict;
use warnings;
require "scripts/common.pl";

my $app = "pointcorrelation";

#my $transformarg = "--nospliceauto";
my $transformarg = "--nosplice --utilstats ";

#my $base = "splicefixed";
my $base = "block";

my $mem = "12G";
#my @sizes = (100000, 200000, 290000);
my $depth = 9;
#my @blocks = (256, 512, 1024, 2048);
my @blocks = (0);
my $rad = "0.4";
my @sizes = (200000);
my @inputs = ("input/nearestneighbor/covtype.7d.gz",
	"input/nearestneighbor/mnist.7d.gz");
my @sorts = qw/true false/;

exec_cmd("rm -f stats.csv");
exec_cmd("rm -f nncorrect.csv");
exec_cmd("ant clean-app-custom -Dapp=$app -Dbase=$base");
exec_cmd("ant transform-app-custom -Dapp=$app -Dbase=$base " .
			"-Dargs='--outdir $base $transformarg ".
			"--utilstats ${app} util'");
exec_cmd("ant compile-app-custom -Dapp=$app -Dbase=$base ");

foreach my $input (@inputs) {
foreach my $size (@sizes) {
foreach my $sort (@sorts) {
foreach my $block (@blocks) {
		exec_cmd("ant run-launcher -Dapp=$app -Dbase=$base " .
			"-Dargs='--desc $base --splicedepth $depth --blocksize $block ".
			"${app}.Main $sort 7 $rad $size $input'");
			}
		}
	}
}

die "finished\n";
